#include "Structures.H"
#include "List.H"
#include "List.C"
#include <iostream.h>

void CheckMember(FishList *fl, Fish *f, char *a);

int main()
{
  Fish *a, *b, *c, *d, *e, *f, *g, *h, *i, *j;
  Fish **fa;
  FishList *lista, *listb;
  ListGenerator<Fish> *gen;

 
  a = new Fish(.1,.1,.1,.1,0);
  b = new Fish(-.1,.1,.1,.1,1);
  c = new Fish(.1,-.1,.1,.1,2);
  d = new Fish(.1,.1,-.1,.1,3);
  e = new Fish(.1,.1,.1,-.1,4);
  f = new Fish(.2,-.1,.1,.1,5);
  g = new Fish(.2,.1,-.1,.1,6);
  h = new Fish(.2,.1,.1,-.1,7);
  i = new Fish(.2,.2,.1,.1,8);
  j = new Fish(.2,.1,.2,.1,9);

  //  dumb.Add(a);
  
  fa = new (Fish*)[10];

  fa[0] = a;
  fa[1] = b;
  fa[2] = c;
  fa[3] = d;
  fa[4] = e;
  fa[5] = f;
  fa[6] = g;
  fa[7] = h;
  fa[8] = i;
  fa[9] = j;

  gen = new ListGenerator<Fish>(fa, 10);

  lista = gen->GenerateList();
  listb = gen->GenerateList();

  cout << "List A\n\n";
  lista->TestPrint(cout);
  cout << "\nList B\n\n";
  listb->TestPrint(cout);

  lista->Add(a);
  lista->Add(c);
  lista->Add(f);

  listb->Add(b);
  listb->Add(e);
  listb->Add(j);

  cout << "\n\nList A\n\n";
  lista->TestPrint(cout);
  cout << "\nList B\n\n";
  listb->TestPrint(cout);

  CheckMember(lista, a, "List A");
  CheckMember(listb, a, "List B");
  CheckMember(lista, i, "List A");
  CheckMember(lista, i, "List B");

  cout << "Removing first from B\n";
  cout << "Removing second from A\n";
  cout << "Removing fifth from A\n";

  lista->Remove(c);
  lista->Remove(f);
  listb->Remove(b);

  cout << "\n\nList A\n\n";
  lista->TestPrint(cout);
  cout << "\nList B\n\n";
  listb->TestPrint(cout);
  
  CheckMember(lista, c, "List A");
  CheckMember(listb, c, "List B");
  CheckMember(lista, b, "List A");
  CheckMember(listb, b, "List B");

  cout << "Elements in A " << lista->NumElements() << "\n";
  cout << "Elements in B " << listb->NumElements() << "\n";

  cout << "\nPrinting out elements of B\n\n";
  listb->Reset();
  Fish *temp;

  while (temp = listb->Next())
    temp->TestPrint(cout);
  cout << "\n\n";

  
  CheckMember(listb, b, "List B");
  CheckMember(listb, e, "List B");
  CheckMember(listb, j, "List B");

  cout << "\n\nDoing a remove all on B\n";
  listb->RemoveAll();

  cout << "\n\nList A\n\n";
  lista->TestPrint(cout);
  cout << "\nList B\n\n";
  listb->TestPrint(cout);

  CheckMember(listb, b, "List B");
  CheckMember(listb, e, "List B");
  CheckMember(listb, j, "List B");

}

void CheckMember(FishList *fl, Fish *f, char *a)
{
  cout << "This fish is ";
  if (!(fl->Member(f)))
    cout << "not ";
  cout << "a member of " << a << "\n";
  cout << "   ";
  f->TestPrint(cout);
}





