#include "Structures.H"
#include "FishUtils.H"

#include <iostream.h>

int main(int argc, char **argv)
{
  Fish **fish_array;
  int i;
  Node *testing;

  if (!ProcessArguments(argc, argv))
    return -1;

  ComputeDimensions();

  fish_array = new (Fish*)[gNumberFish];
  InitializeFish(fish_array, gNumberFish);
  
  for(i = 1; i <= 16; i++)
    {
      testing = new Node(0,i, gNumberFish, fish_array);
      if (testing->theGrid->VerifyLayout())
        cout << "Testing size " << i << " was succeful!\n";
      else
        {
          cout << "Who would of thought " << i << " is broke\n";
          exit(-1);
        }
    }
  
  for(i = 1; i <= 16; i++)
    {
      testing = new Node(0,i, gNumberFish, fish_array);
      cout << "\n";
      testing->GraphLayout(cout);
      cout << "\n";
    }

  cout << "\n\nNow testing individual grid layout stuff\n\n";

  for (i = 1; i <=16; i++)
    for (int nn = 0; nn < i; nn++)
      {
        testing = new Node(nn,i, gNumberFish, fish_array);

        if (nn == 0)
          {
            cout << "****Testing using " << i << " node.\n";
            testing->GraphLayout(cout);
            cout << "\n";
          }
        cout << "Testing Node #" << nn << " out of " << i << "\n";
        if (!(testing->theGrid->VerifyLayout()))
          cout << "****Who would of thought " << i << ", " << nn <<
            " is broke\n";
        testing->GraphNeighbors(cout);
        cout << "\n";
      }
}
